﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ustawienia
{
    class Osoba
    {
        private int polePrywatne;
        public static string Gatunek = "Reptylianin";
        public int Własność { get; }

        public string Imię, Nazwisko;
        public DateTime DataUrodzenia;
        public int Telefon;
    }

    class Program
    {
        private static void wyświetlStanObiektu(Type type, Dictionary<string, string> values)
        {
            Console.WriteLine("\nStan obiektu " + nameof(type) + " typu " + type.Name);
            foreach (KeyValuePair<string, string> value in values)
            {
                Console.WriteLine(value.Key + " - " + value.Value);
            }
        }

        static void Main(string[] args)
        {
            List<string> memberNames = SettingsManager<Osoba>.ExtractMembersNames();
            Console.WriteLine("Składowe typu " + typeof(Osoba).Name + ":");            
            foreach (string memberName in memberNames)
                Console.WriteLine(memberName);

            Osoba ja = new Osoba()
            {
                Imię = "Jacek",
                Nazwisko = "Matulewski",
                DataUrodzenia = new DateTime(1972, 6, 23),
                Telefon = 123456789
            };
            SettingsManager<Osoba> sm = new SettingsManager<Osoba>(ja, new CultureInfo("pl-PL"));
            wyświetlStanObiektu(typeof(Osoba), sm.Values);
            sm.SaveToXml("osoba.xml");

            SettingsManager<Osoba> sm1 = SettingsManager<Osoba>.LoadFromXml("osoba.xml", new CultureInfo("pl-PL"));
            wyświetlStanObiektu(typeof(Osoba), sm1.Values);
        }
    }
}
